#import "AccountViewController.h"

@implementation AccountViewController

@synthesize apikeyTextField;
@synthesize privatekeyTextField;
@synthesize path;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        //Custom initialization
        //gee the plist path
        NSBundle* mainBundle;
        mainBundle = [NSBundle mainBundle];
        NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
        path = [[paths objectAtIndex:0]stringByAppendingPathComponent:@"Account.plist"];
        
        if([[NSFileManager defaultManager] fileExistsAtPath:path] == NO){
            [[NSFileManager defaultManager] createFileAtPath:path contents:nil attributes:nil];
            NSDictionary *nilDict = [[NSDictionary alloc]init];
            [nilDict writeToFile:path atomically:YES];
        }

    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    NSDictionary *keys = [[NSDictionary alloc]initWithContentsOfFile:path];

    self.title = @"Account";
    apikeyTextField.text = [keys objectForKey:@"api_key"];
    privatekeyTextField.text = [keys objectForKey:@"private key"];
    
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

-(void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    
         
    NSDictionary *keys = [[NSDictionary alloc]initWithObjectsAndKeys: apikeyTextField.text,@"api_key",
                                                                     privatekeyTextField.text, @"private key",nil];

    NSBundle* mainBundle;
    mainBundle = [NSBundle mainBundle];
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *path1 = [[paths objectAtIndex:0]stringByAppendingPathComponent:@"Account.plist"];
    [keys writeToFile:path1 atomically:YES];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end