#import "JobContainer.h"

@implementation JobContainer

@synthesize jobs;

-(id)init{
    [super init];

    //read the plsit file
    NSBundle* mainBundle;
    NSString* fileName;
    mainBundle = [NSBundle mainBundle];
    fileName = [mainBundle pathForResource:@"Jobs" ofType:@"plist"];
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    path = [[paths objectAtIndex:0]stringByAppendingPathComponent:@"Jobs.plist"];

    if([[NSFileManager defaultManager] fileExistsAtPath:path] == NO){
        [[NSFileManager defaultManager] createFileAtPath:path contents:nil attributes:nil];
        NSMutableArray *nilArray = [[NSMutableArray alloc]init];
        [nilArray writeToFile:path atomically:YES];
    }

    //get the job list
    jobs = [NSMutableArray arrayWithContentsOfFile:path];
    
    return self;
}

-(NSMutableArray*)getJobs{
    return jobs;
   }


-(NSMutableDictionary*)getJob:(NSString*)job_id{
    for(NSMutableDictionary *job_ in jobs){
        NSString *job_id_ = [job_ objectForKey:@"job_id"];
        if([job_id_ isEqualToString:job_id]){
            return job_;
        }
    }
}


-(void)appendJob:(NSMutableDictionary*)job{
    [jobs insertObject:job atIndex:0];
    [jobs writeToFile:path atomically:YES];
}

-(void)deleteJob:(NSString*)job_id{
    NSDictionary *job = [self getJob:job_id];
    [jobs removeObject:job];
    [jobs writeToFile:path atomically:YES];
}

-(void)deleteAllJob{
    [jobs removeAllObjects];
    [jobs writeToFile:path atomically:YES];
    
}


-(NSMutableDictionary*)mapToJob:(NSDictionary*)responseJSON{
    NSDictionary *json = [[responseJSON objectForKey:@"response"]objectForKey:@"job"];
    NSMutableDictionary *job = [[[NSMutableDictionary alloc]init]autorelease];
    
    [job setValue:[json objectForKey:@"job_id"] forKey:@"job_id"];
    [job setValue:[json objectForKey:@"slug"] forKey:@"slug"]; 
    [job setValue:[json objectForKey:@"credits"] forKey:@"credits"]; 
    [job setValue:[json objectForKey:@"status"] forKey:@"status"];
    [job setValue:[json objectForKey:@"tier"] forKey:@"tier"];
    [job setValue:[json objectForKey:@"lc_src"] forKey:@"lc_src"];
    [job setValue:[json objectForKey:@"lc_tgt"] forKey:@"lc_tgt"];
    [job setValue:[json objectForKey:@"body_src"] forKey:@"body_src"]; 
    [job setValue:[json objectForKey:@"body_tgt"] forKey:@"body_tgt"]; 
    [job setValue:[json objectForKey:@"custom_data"] forKey:@"custoom_data"];
    [job setValue:[json objectForKey:@"auto_approve"] forKey:@"auto_approve"];
    [job setValue:[json objectForKey:@"type"] forKey:@"type"]; 
    
    return job;
    
}

-(void)updateJob:(NSString*)job_id job:(NSDictionary*)updateJob{
    NSDictionary *job = [self getJob:job_id];
    NSUInteger index = [jobs indexOfObject:job];
    
    NSMutableDictionary *mupdateJob = [self mapToJob:updateJob];
    
    [jobs replaceObjectAtIndex:index withObject:mupdateJob];
    [jobs writeToFile:path atomically:YES];
}



@end
