#import "MasterViewController.h"
#import "DetailViewController.h"
#import "AddJobViewController.h"
#import "AccountViewController.h"
#import "RESTJobs.h"
#import "RESTJob.h"


@implementation MasterViewController

@synthesize detailViewController = _detailViewController;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = NSLocalizedString(@"Job List", @"Master");
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
            self.clearsSelectionOnViewWillAppear = NO;
            self.contentSizeForViewInPopover = CGSizeMake(320.0, 600.0);
        }
    }
    

    
    return self;
}
							
- (void)dealloc
{
    [_detailViewController release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
        [self.tableView selectRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0] animated:NO scrollPosition:UITableViewScrollPositionMiddle];
    }
    
    UIBarButtonItem *addJobButton = [[UIBarButtonItem alloc]initWithBarButtonSystemItem:UIBarButtonSystemItemAdd target:self action:@selector(addJob)];
    
    self.navigationItem.rightBarButtonItem = addJobButton;
    [addJobButton release];
    
    UIBarButtonItem *configButton = [[UIBarButtonItem alloc] initWithTitle:@"Account"
                                                                     style:UIBarButtonItemStyleBordered target:self action:@selector(configAccount)];
    
    self.navigationItem.leftBarButtonItem = configButton;
    [configButton release];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.tableView reloadData];    
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{    
    JobContainer *jc = [[[JobContainer alloc]init]autorelease];
    NSMutableArray *jobs = [jc getJobs];
    return [jobs count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
            cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        }
    }    
    JobContainer *jc = [[[JobContainer alloc]init]autorelease];
    NSMutableArray *jobs = [jc getJobs];
    NSMutableDictionary *job = [jobs objectAtIndex:indexPath.row];
    //    cell.textLabel.text = NSLocalizedString(@"Detail", @"Detail");
    cell.textLabel.text = [job objectForKey:@"slug"];
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
	    if (!self.detailViewController) {
	        self.detailViewController = [[[DetailViewController alloc] initWithNibName:@"DetailViewController_iPhone" bundle:nil]autorelease];
	    }
        
        JobContainer *jc = [[JobContainer alloc]init];
        NSMutableArray *jobs = [jc getJobs];
        
        //set parameters for the next view
        NSMutableDictionary *job = [jobs objectAtIndex:indexPath.row];
        NSString *job_id = [job objectForKey:@"job_id"];
        NSString *tier = [job objectForKey:@"tier"];
        NSString *credits = [job objectForKey:@"credits"];
        NSString *lc_src = [job objectForKey:@"lc_src"];
        NSString *lc_tgt = [job objectForKey:@"lc_tgt"];
        NSString *status = [job objectForKey:@"status"];
        NSMutableString *body_src = [job objectForKey:@"body_src"];
        NSMutableString *body_tgt = [job objectForKey:@"body_tgt"];

        self.detailViewController.job_id = job_id;
        self.detailViewController.tier = tier;
        self.detailViewController.credits = credits;
        self.detailViewController.lc_src = lc_src;
        self.detailViewController.lc_tgt = lc_tgt;
        self.detailViewController.status = status;
        self.detailViewController.body_src = body_src;
        self.detailViewController.body_tgt = body_tgt;
        
        
        //transition of view
        [self.navigationController pushViewController:self.detailViewController animated:YES];
        self.detailViewController = nil;
        
    }
}



-(void)addJob{    
    //transition of view
    AddJobViewController *addJobController = [[[AddJobViewController alloc]initWithNibName:@"AddJobViewController" bundle:nil]autorelease];
    [self.navigationController pushViewController:addJobController animated:YES];
    
}

-(void)configAccount{
    //transition of view
    AccountViewController *accountController = [[[AccountViewController alloc]initWithNibName:@"AccountViewController" bundle:nil]autorelease];
    [self.navigationController pushViewController:accountController animated:YES];

}

@end
