#import "RESTJob.h"
#import "Crypto.h"
#import "SBJson.h"

@implementation RESTJob

-(id)init{
    [super init];
    baseUrl = [NSMutableString stringWithString:@"http://api.sandbox.mygengo.com/v1/translate/job/"];
    return self;
}


-(NSDictionary*)getTranslateJob:(NSString*)job_id{
    NSString *_method = @"GET";
    [baseUrl appendString:job_id];
    
    //set parameters (ToDo:rewrite the hard coding)
    NSString *api_key_enc = (NSString*)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)api_key, NULL, CFSTR (";,/:()=@+$#"), kCFStringEncodingUTF8); //URL ecnode  the api_key
    NSString *encParams = [[NSString alloc]initWithFormat:@"api_key=%@&ts=%@",api_key_enc,timestamp];
    NSString *api_sig = [Crypto hashHmac:private_key Data:encParams];
    NSString *paramStr = [[NSString alloc] initWithFormat:@"?%@&api_sig=%@",encParams,api_sig];
    
    //call API
    NSString *urlString = [baseUrl stringByAppendingString:paramStr];
    NSString *responseString = [self rest:urlString Method:(NSString*)_method Parameter:nil];
    NSDictionary *jsonDictionary = (NSDictionary*)[responseString JSONValue];

    return jsonDictionary;    
}


-(NSDictionary*)deleteTranslateJob:(NSString*)job_id{
    NSString *_method = @"DELETE";
    [baseUrl appendString:job_id];

    //set parameters
    NSMutableDictionary *parameters = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                       api_key,@"api_key",
                                       timestamp,@"ts",
                                       nil];    
    //make JSON string (sorted by key)
    SBJsonWriter *writer = [[[SBJsonWriter alloc] init] autorelease];
    writer.sortKeys = YES;
    
    //add api_sig
    NSString *parameterString = [self _buildParameters:parameters];
    NSString *api_sig = [Crypto hashHmac:private_key Data:parameterString];    
    [parameters setObject:api_sig forKey:@"api_sig"];
    NSString *paramStr = [self _buildParameters:parameters];
    
    //call API
    [baseUrl appendString: @"?"];
    [baseUrl appendString:paramStr];    
    NSString *responseString = [self rest:baseUrl Method:_method Parameter:nil];
    NSDictionary *jsonDictionary = (NSDictionary*)[responseString JSONValue];
    
    return jsonDictionary;

}


-(NSDictionary*)postTranslateJob:(NSMutableDictionary*)payload{
    NSString *_method = @"POST";
    
    //make a payload
    if(payload == nil){
        UIAlertView *alert =
        [[UIAlertView alloc] initWithTitle:@"Warning:" message:@"No text!"
                                  delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
    }else{   
        NSDictionary *payloadRequest = [NSDictionary dictionaryWithObjectsAndKeys:
                                        payload,@"job",
                                        nil];
        NSString *payloadString = [payloadRequest JSONRepresentation];
        
        //set parameters
        NSMutableDictionary *parameters = [NSMutableDictionary dictionaryWithObjectsAndKeys:
                                api_key,@"api_key",
                                payloadString,@"data",
                                timestamp,@"ts",nil];    
        //make JSON string (sorted by key)
        SBJsonWriter *writer = [[[SBJsonWriter alloc] init] autorelease];
        writer.sortKeys = YES;
        
        //add api_sig
        NSString *paramStr = [writer stringWithObject:parameters];
        NSString *api_sig = [Crypto hashHmac:private_key Data:paramStr];
        [parameters setObject:api_sig forKey:@"api_sig"];
        
        //call API
        NSString *responseString = [self rest:baseUrl Method:_method Parameter:parameters];
        NSDictionary *jsonDictionary = (NSDictionary*)[responseString JSONValue];
    
        return jsonDictionary;
    }
}


//ToDo:PUT methods

//make a query parameter
- (NSString*)_buildParameters:(NSDictionary *)params {
    NSMutableString *s = [NSMutableString string];
    
    NSString *key;
    for ( key in params ) {
        NSString *uriEncodedValue = [self _uriEncodeForString:[params objectForKey:key]];
        [s appendFormat:@"%@=%@&", key, uriEncodedValue];
    }
    
    if ( [s length] > 0 ) {
        [s deleteCharactersInRange:NSMakeRange([s length]-1, 1)];
    }
    return s;
}

- (NSString*)_uriEncodeForString:(NSString *)str {
    return [((NSString*)CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                                                (CFStringRef)str,
                                                                NULL,
                                                                (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                                kCFStringEncodingUTF8)) autorelease];
}




@end

    

