#import "RESTJobs.h"
#import <CommonCrypto/CommonHMAC.h>
#import "SBJson.h"
#import "QSUtilities.h"
#import "JobContainer.h"
#import "Crypto.h"

@implementation RESTJobs

-(id)init{
    [super init];
    baseUrl = [NSMutableString stringWithString:@"http://api.sandbox.mygengo.com/v1/translate/jobs/"];
    return self;
}


-(NSDictionary*)getTranslateJobs{
    NSString *_method = @"GET";
    
    //URL encode the api_key
    NSString *api_key_enc = (NSString*)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)api_key, NULL, CFSTR (";,/:()=@+$#"), kCFStringEncodingUTF8);
    
    //make query string
    NSString *encParams = [[NSString alloc]initWithFormat:@"api_key=%@&ts=%@",api_key_enc,timestamp];
    NSString *api_sig = [Crypto hashHmac:private_key Data:encParams];
    NSString *paramStr = [[NSString alloc] initWithFormat:@"?%@&api_sig=%@",encParams,api_sig];

    //call API
    NSString *urlString = [baseUrl stringByAppendingString:paramStr];
    NSString *responseString = [self rest:urlString Method:_method Parameter:nil];
    NSDictionary *jsonDictionary = (NSDictionary*)[responseString JSONValue];
    return jsonDictionary;
   
}

-(NSDictionary*)getTranslateJobs:(NSArray*)job_ids{
    //implode array
    NSString *idString = [[NSMutableString alloc]init];
    idString = [job_ids componentsJoinedByString:@","];
    [baseUrl appendString:idString];
    

    NSDictionary *jsonDictionary =  [self getTranslateJobs];
    return jsonDictionary;

}



@end