#import "RESTLanguage.h"
#import "Crypto.h"
#import "SBJson.h"

@implementation RESTLanguage

-(id)init{
    [super init];
    baseUrl = [NSMutableString stringWithString:@"http://api.sandbox.mygengo.com/v1/translate/service/"];
    return self;
}

-(NSDictionary*)getLanguage{
    [baseUrl appendString:@"languages"];
    NSString *_method = @"GET";
        
    //URL encode the api_key
    NSString *api_key_enc = (NSString*)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)api_key, NULL, CFSTR (";,/:()=@+$#"), kCFStringEncodingUTF8);
    
    //make a query string
    NSString *encParams = [[NSString alloc]initWithFormat:@"?api_key=%@&ts=%@",api_key_enc,timestamp];
    
    //call API
    NSString *urlString = [baseUrl stringByAppendingString:encParams];
    NSString *responseString = [self rest:urlString Method:(NSString*)_method Parameter:nil];
    NSDictionary *jsonDictionary = (NSDictionary*)[responseString JSONValue];
    return jsonDictionary;
}


-(NSDictionary*)getLanguagePairs:(NSString*)lc_src{
    [baseUrl appendString:@"language_pairs"];
    NSString *_method = @"GET";
    //URL encode the api_key
    NSString *api_key_enc = (NSString*)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)api_key, NULL, CFSTR (";,/:()=@+$#"), kCFStringEncodingUTF8);
    
    //make a query string
    NSString *encParams = [[NSString alloc]initWithFormat:@"?api_key=%@&ts=%@&lc_src=%@",api_key_enc,timestamp,lc_src];
    
    //call API
    NSString *urlString = [baseUrl stringByAppendingString:encParams];
    NSString *responseString = [self rest:urlString Method:(NSString*)_method Parameter:nil];
    NSDictionary *jsonDictionary = (NSDictionary*)[responseString JSONValue];
    return jsonDictionary;
}

@end